/********************************************
OBIETTIVO: CONOSCERE ITERATORI e FOR AVANZATI
*********************************************/

/*
Supponiamo di creare la seguente istanza ArrayList e di inserirvi alcune parole:

	ArrayList<String> words = new ArrayList<String>();

Scrivere il codice per stampare le parole di 4 lettere usando:
1. un indice
2. un iteratore
3. un for avanzato	
*/
	
import java.util.*;

public class words {
		
   public static void main (String[ ] args){

	ArrayList<String> words = new ArrayList<String>();
	String word;

	words.add ("for");
	words.add ("then");
	words.add ("else");
	words.add ("if");
	words.add ("true");

	// 1: uso dell'indice
	for (int i = 0; i < words.size(); i++) {
	   word = words.get(i);
   	   if (word.length() == 4) System.out.println (word);
	} // indice

	// 2: uso dell'iteratore
	Iterator<String> itr = words.iterator();
	while (itr.hasNext()) {
	   word = itr.next();
	   if (word.length() == 4) System.out.println (word);
	} // iteratore

	// 3: uso del for avanzato
	for (String s : words)
	   if (s.length() == 4) System.out.println (s);
   } // main

} // class words

/******
RIPASSO:
Nel Java Collections Framework, gli iteratori sono definiti dall'iterfaccia Iterator,
dichiarata nella Java Collections API (package java.util):

public interface Iterator {
    boolean hasNext();
    Object next();
    void remove();
}

Come si ottiene un iteratore su una data collezione?
Invocando il metodo:  public Iterator iterator() dichiarato nell'interfaccia Collection. 
*/
